# Simulations- und Optimierungsrechnungen im Joghurt-Beispiel
setwd("C:/Users/Alpha/Conjointanalyse/R")
library(fastDummies)
source(file="Simul.r") # falls obige Funktionen in simul.r stehen
I=4; J_SQ=5; K=3; L=c(2,2,3); p=sum(L)
# Verpackg. Geschmack Preis
# Plas Glas Saur Mild 0.4 0.5 0.7
Beta=matrix(c(0.00,0.06,0.00,0.44,0.33,0.17,0.00,
              0.00,0.06,0.44,0.00,0.33,0.17,0.00,
              0.05,0.00,0.14,0.00,0.55,0.27,0.00,
              0.00,0.53,0.00,0.27,0.13,0.07,0.00),nrow=I,ncol=p,byrow=TRUE)
w=c(20000,10000,5000,10000)
X_SQ=matrix(c(0, 1, 0, 1, 0, 0, 1,
              1, 0, 0, 1, 1, 0, 0,
              1, 0, 0, 1, 1, 0, 0,
              1, 0, 1, 0, 0, 1, 0,
              1, 0, 0, 1, 0, 1, 0),
nrow=J_SQ,ncol=p,byrow=TRUE)
d= matrix(c(0.20,0.00,0.10,0.00,0.00,0.10,0.30,
            0.20,0.00,0.10,0.00,0.00,0.10,0.30,
            0.20,0.00,0.10,0.00,0.00,0.10,0.30,
            0.20,0.00,0.10,0.00,0.00,0.10,0.30),
            nrow=I,ncol=p,byrow=TRUE)
f= matrix(c(0.00,0.00,0.00,1000,0.00,0.00,0.00),
            nrow=1,ncol=p,byrow=TRUE)
X_all=expand.grid(A=1:2,B=1:2,C=1:3)
X_all=dummy_cols(X_all,select_columns=c("A","B","C"))
X_all=as.matrix(subset(X_all,select=-c(A,B,C))) # Kandidaten
# Simulationsrechnung Status Quo Markt
u=Beta %*% t(X_SQ); u; Regel=1; alpha=20
P=Prob(X_SQ,Beta,Regel,alpha); P
M=Absatz(X_SQ,Beta,w,Regel,alpha); M
m=Marktanteil(X_SQ,Beta,w,Regel,alpha); m
G=Gewinn(X_SQ,Beta,w,d,f,Regel,alpha); G
# Optimierungsrechnung Einzelprodukt
Regel=2; alpha=1; J_all=dim(X_all)[1]
G_all=1:J_all; G_opt=-1E12; j_opt=0
for (j in 1:J_all){
  X=rbind(X_SQ,X_all[j,]); X # Status Quo plus Neuprodukt
  G=Gewinn(X,Beta,w,d,f,Regel,alpha); G_all[j]=G[J_SQ+1]
  if (G[J_SQ+1]>G_opt){j_opt=j; G_opt=G[J_SQ+1]}
}
G_opt; j_opt; X_all[j_opt,]

# Optimierungsrechnung Produktline (Regel=1:FC,=2:BTL,=3:Logit)
Regel=2; alpha=1; J_all=dim(X_all)[1]
G_all=matrix(0,nrow=J_all,ncol=J_all); G_opt=-1E12; j1_opt=0; j2_opt=0;
for (j1 in 1:J_all){
  for (j2 in 1:J_all){
    X=rbind(X_SQ,X_all[j1,],X_all[j2,]); X # plus 2 Neuprodukte
    G=Gewinn(X,Beta,w,d,f,Regel,alpha); G_all[j1,j2]=G[J_SQ+1]+G[J_SQ+2]
    if (G_all[j1,j2]>G_opt){j1_opt=j1; j2_opt=j2;
    G_opt=G_all[j1,j2]}
}
}
G_opt; j1_opt; X_all[j1_opt,]; j2_opt; X_all[j2_opt,]
